// Imports
const express = require("express");
const bodyParser = require("body-parser");
const bearerToken = require("express-bearer-token");
// Local Imports
const { Web, StatusCode, Server } = require("./config.json");
// Import Routers
const stashRouter = require("./routes/stash");
// Define Constants & Setup Database
const app = express();
const port = Server.Port;
const timeout = 10 * 60 * 1000;
const debuggingMode = Server.Debug;
const viewOptions = { beautify: false };
// Set Up Express session and View engine
app.use(bearerToken());
app.use(bodyParser.json({ limit: Server.BodyLimit })); // parse application/json
app.use(bodyParser.urlencoded({ limit: Server.BodyLimit, extended: false })); // parse application/x-www-form-urlencoded
app.use(["/nubian/api/stash", "/api/stash", "/stash"], stashRouter);
const startServer = () => {
  var server = app.listen(port, () => {
    console.log("Node version:" + process.versions.node);
    console.log(`Duneserver listening on port ${port}!`);
  });
  server.timeout = timeout;
  server.on("connection", (socket) => socket.setTimeout(timeout));
  process.on("SIGINT", () => {
    console.log("Recieved Shutdown Signal!");
    process.exit();
  });
};
startServer();
